 unit TreeCLGR;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CustomGraph, GraphControlTreeCL, Grids, MyNewgrid,fenarbre,
  ExtCtrls, Buttons,typedef,listarray2,Menus,StructureDonnees,Donnees,ColorStringGrid;

type
  TFormArbre = class(TForm)
    GCT1: TGraphControlTreeCL;
    Splitter1: TSplitter;
    panel1: TPanel;
    ouvrircode: TOpenDialog;
    TabGrid1: TTabGrid;
    PopupMenu1: TPopupMenu;
    Code: TMenuItem;
    Optionslegendes: TMenuItem;
    Splitter2: TSplitter;
    Panel3: TPanel;
    ScrollBox1: TScrollBox;
    Fontedestaxons1: TMenuItem;
    FontDialog1: TFontDialog;
    Afficherleslongueurs1: TMenuItem;
    PanLabelCarac: TPanel;
    PanelOutils: TPanel;
    zoommois: TSpeedButton;
    zoomplus: TSpeedButton;
    annuler: TSpeedButton;
    normal: TSpeedButton;
    pivoter: TSpeedButton;
    Enraciner: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Legendes: TSpeedButton;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label3: TLabel;
    LongTot: TEdit;
    LongPart: TEdit;
    RadioMode: TRadioGroup;
    LabelCarac: TLabel;
    ChoixCode: TRadioGroup;
    Tableaudesdistances: TMenuItem;
//    procedure Button2Click(Sender: TObject);
    procedure AfficheCodeColor(name:string);
    procedure AfficheAColor(etat:string;aColor:TColor;index:integer;AfficherNum:Boolean);
    procedure removelabel;
    procedure legendesClick(Sender: TObject);
    procedure TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GCT1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ActionClick(Sender: TObject);
    procedure OptionslegendesClick(Sender: TObject);
    procedure codeClick(Sender: TObject);
    procedure autoClick(Sender: TObject);
    procedure annulerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure zoomplusClick(Sender: TObject);
    procedure zoommoisClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure LoadTree(FileName:string);
    procedure SaveTree(FileName:string);
    function GetTabName(FileName:string):string;
    procedure GCT1RespClicDownRight(WPoint: TPoint);
    procedure GCT1BeforeInsert(sender: TObject);
    procedure Fontedestaxons1Click(Sender: TObject);
    procedure Afficherleslongueurs1Click(Sender: TObject);
    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure Splitter2CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure FormShow(Sender: TObject);
    procedure RadioModeClick(Sender: TObject);
    procedure GCT1CanClicActivate(WPoint: TPoint; var ret: Boolean);
    procedure GCT1CanClicDown(WPoint: TPoint; var ret: Boolean);
    procedure ChoixCodeClick(Sender: TObject);
    procedure TableaudesdistancesClick(Sender: TObject);
    //procedure Button1Click(Sender: TObject); //rcupre le nom de la matrice associe  un arbre
  private
    NameOfFlagTaxonPro: string;
    AfDExcl,AfD,AfA:TAffichCoul;
    RacineSansDerive:boolean;
    InactiveMouseUp:Boolean;
    procedure VerifieTypeRacine;
    procedure RAZSelCAr;
    procedure AjusteAffArbre;
    { Dclarations prives }
  public  { Dclarations publiques }
    ModeAfficheCarac :boolean ;
    ModeEdition:boolean;
    MesCarD:TCarDs;
    procedure ChargeTabGrid;
    procedure Verifierarbre;
    procedure ChangeMode;
    Procedure TabGrid1MouseDownFixe(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
    procedure AjusteActive;
    procedure AjusteCode;
    procedure RetourSelection(Sender:TObject);
    procedure AjusteTableau;
    Procedure ColoreMatrice;
  end;

var
  FormArbre: TFormArbre;

implementation

uses optionleg,PhylMain, PhylChoi, PhylTrier,group2,
  phylParente, FenCaractAncetre, PhyloRech, AffichTabCod,FenTabDist;

{$R *.DFM}


Procedure TFormArbre.ColoreMatrice;
Var
  i,j,n:integer;
  etat:string;
  NomCaractere:string;
begin
  MesCarD.EtablitAffichage(TabGrid1);
  if FicheCarAncetre.Visible then
    begin
      For i:=1 to FicheCarAncetre.ColorStringGrid.RowCount-1 do
        begin
          if AfficCoulIdentiques(FicheCarAncetre.ColorStringGrid.AffichCell[1,i],ConvertitAffCelAffCoul(ModDeriveExcl)) then
            begin
              NomCaractere:=FicheCarAncetre.ColorStringGrid.Cells[0,i];
              n:=TabGrid1.Rows[0].IndexOf(NomCaractere);
              if n>0 then
                begin
                  etat:=FicheCarAncetre.ColorStringGrid.Cells[1,i];
                  for j:=1 to TabGrid1.RowCount-1 do
                    begin
                      if TabGrid1.Cells[n,j]=etat then TabGrid1.AffichCell[n,j]:=ModDeriveExcl;
                    end;
                end;
            end;
        end;
    end;
  TabGrid1.Refresh;
end;
procedure TFormArbre.Verifierarbre;
Var
  i:integer;
  Tax:TTaxon;
begin
  GCT1.RAZFossiles;
  GCT1.RAZExternes;
  For i:=0 to LaSousCollection.Taxons.NbTaxons-1 do
    begin
      Tax:=TTaxon(LaSousCollection.Taxons[i]);
      if LaSousCollection.EstFossile(i) then
        GCT1.AjouteFossile(Tax.Nom);
      if LaSousCollection.EstExterne(i) then
        GCT1.AjouteExterne(Tax.Nom);
    end;
end;
procedure TFormArbre.ChangeMode;
begin
  if ModeEdition then
    begin
      GCT1.EstModifiable:=True;
      TabGrid1.OnMouseDown:=TabGrid1MouseDown;
      TabGrid1.Options:=TabGrid1.Options-[goRowMoving,goColMoving];
      TabGrid1.RAZInvalidateCol;
      RadioMode.ItemIndex:=0;
    end
  else
    begin
      GCT1.EstModifiable:=False;
      TabGrid1.OnMouseDown:=TabGrid1MouseDownFixe;
      TabGrid1.Options:=TabGrid1.Options+[goRowMoving,goColMoving];
      TabGrid1.RAZInvalidateCol;
      RadioMode.ItemIndex:=1;
    end;
end;

procedure TFormArbre.legendesClick(Sender: TObject);
begin
   if legendes.Tag=0 then
   begin
     legendes.Tag:=1;
     GCT1.TreePage.Flag_Legende:=true;
     GCT1.TreePage.CreateLeg;
     GCT1.TreePage.ChangeCoordGraphObjects;
     optionsLegendes.Enabled:=true;
   end
   else
     begin
      legendes.Tag:= 0;
      GCT1.TreePage.Flag_Legende:=false;
      GCT1.TreePage.DeleteLeg;
      optionslegendes.enabled:=false;
     end;
   GCT1.invalidate;
end;

procedure TFormArbre.removelabel;
var
i:integer;
Temp:TComponent;

begin
for I := ScrollBox1.ComponentCount - 1 downto 0 do
  begin
    Temp := ScrollBox1.Components[I];
    if (Temp is TControl) then
    begin
      ScrollBox1.RemoveComponent(Temp);
      Temp.free;
    end;
 end;
 LabelCarac.Caption:='';
end;

procedure TFormArbre.AfficheCodeColor(name:string);
var
  //compt,noRow,index,code : integer;
  etat : string; //,codeStr
  //aColor:TColor;
  i:integer;
  UnCarD:TCaractD;
  AfficherNum:Boolean;
begin
  removelabel;
  LabelCarac.Caption:=name;
  ScrollBox1.invalidate;
  UnCarD:=MesCarD.GetCarD(name);
  if UnCarD<>Nil then
    begin
      AfficherNum:=(UnCarD.TypeCarD=1)and
                   (((UnCarD.ListeEtats[UnCarD.ListeEtats.Count-1]<>'?')and (UnCarD.ListeEtats.Count>2))or(UnCarD.ListeEtats.Count>3));
      For i:=0 to UnCarD.ListeEtats.Count-1 do
        begin
          etat:=UnCarD.ListeEtats[i];
          if etat<>'' then AfficheAColor(etat,NodeColor[i+1],i,AfficherNum);
{            begin
              if UnCarD.LitAffichCellEtat(1).Active then
                aColor:=LaSousCollection.Affichage[name,etat].CouleurFond
              else
                aColor:=NodeColor[i+1];
              AfficheAColor(etat,aColor,i);
            end; }
        end;
      if UnCarD.ListeEtats[UnCarD.ListeEtats.Count-1]<>'?' then
        begin
          AfficheAColor('?',clWhite,UnCarD.ListeEtats.Count,false);
        end
    end;
  
{  compt:=2;
  index:=0;

  noRow:= GCT1.TabCod.IndexOfRow(name);

  removelabel;
  LabelCarac.Caption:=name;
  ScrollBox1.invalidate;
  while (compt <= (GCT1.TabCod.ColCount[noRow])) do
    begin
      etat:=GCT1.TabCod.StrItems[noRow,compt];
      if ((etat<>'') and (Trim(etat)<>'')) then
        begin
          codeStr:=GCT1.TabCod.StrItems[noRow,compt+1];
          code:=StrToInt(codeStr);
          aColor:=NodeColor[code+1];
          AfficheAColor(etat,aColor,index);
        end;
      index:=index+1;
      compt:=compt+2;
    end;}
end;

procedure TFormArbre.AfficheAColor(etat:string;aColor:TColor;index:integer;AfficherNum:Boolean);
var
  Instance1:TCaseCoul;
  Instance2:TLabel;
  typetat:string;
  TopBase:integer;
  AfficBase:TAffichCoul;
  //AffichInc:TAffichCoul;
begin
  AfficBase.Active:=True;
  AfficBase.CouleurTexte:=ClBlack;
  AfficBase.CouleurFond:=AColor;
  AfficBase.styleFond:=bsSolid;
  AfficBase.CouleurContour:=clBlack;
  if index=0 then
    begin
      typetat:='(tat primitif)';
      TopBase:=6;
    end
  else
    if etat<>'?' then
      begin
        typetat:='(tat driv';
        if AfficherNum then typetat:=typetat +' '+ intToStr(index)+')'
        else typetat:=typetat +')';
        TopBase:=6;
      end
    else
      begin
        typetat:='';
        TopBase:=12;
        AfficBase.styleFond:=bsDiagCross;
        AfficBase.CouleurFond:=ClBlack;
      end;
//  Instance1:=TLabel.Create(ScrollBox1);
  Instance1:=TCaseCoul.Create(ScrollBox1);
  Instance1.parent:=ScrollBox1;
  instance1.name:='';
  instance1.top:=10+(index*10)+(index*20);
  instance1.left:=10;
  instance1.Height:=20;
  instance1.width:=20;
  //(instance1 as TLabel).Color:=aColor;
  instance1.EpaisseurContour:=1;
  instance1.AffichCoul:=AfficBase;
  instance1.Paint;

  Instance2:=TLabel.Create(ScrollBox1);
  Instance2.parent:=ScrollBox1;
  Instance2.Font.Color:=clWhite;

  if typetat='' then (instance2 as TLabel).Caption:=etat
  else (instance2 as TLabel).Caption:=etat+#10+#13+typetat;
  instance2.top:=TopBase+(index*10)+(index*20);
  instance2.left:=10+20+10;
end;
procedure TFormArbre.AjusteAffArbre;
Var
  i:integer;
  Nomcar:string;
  Trouve:Boolean;
  UnCarD:TCaractD;
begin
// recherche d'une colonne slectionne (en fait invalide);
  Trouve:=False;
  NomCar:='';
  for i:=1 to TabGrid1.ColCount-1 do
    if TabGrid1.InvalidateCol[i] then
      begin
        Trouve:=True;
        NomCar:=TabGrid1.Cells[i,0];
        Break;
      end;
  if Trouve Then
    begin
      UnCarD:=MesCarD.GetCarD(NomCar);
      if UnCarD<>Nil then
        for i:=0 to UnCarD.ListeEtats.Count-1 do
          if UnCarD.ListeEtats[i]<>'' then
            begin
              if UnCarD.ListeEtats[i]='?' then NodeColor[i+1]:=clWhite
              else if UnCarD.LitAffichCellEtat(i).Active then
                begin
                  if UnCarD.LitAffichCellEtat(i).CouleurFond=clWhite then
                    begin
                      if UnCarD.LitAffichCellEtat(i).CouleurContour<>clBlack then
                        NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurContour
                      else if UnCarD.LitAffichCellEtat(i).CouleurTexte<>clBlack  then
                        NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurTexte
                      else
                        NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurFond;
                    end
                  else
                    NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurFond;
                end
              else CouleursParDefaut;
            end;
      // changer la lgende
      AfficheCodeColor(NomCar);
      GCT1.OnChangeSelectCarac(NomCar);
      GCT1.invalidate;
    end;
end;
procedure TFormArbre.RAZSelCAr;
Var
  i:integer;
begin
  for i:=1 to TabGrid1.ColCount-1 do TabGrid1.InvalidateCol[i]:=false;
  if GCT1.TreePage.Flag_Legende=true then
    begin
      GCT1.TreePage.Flag_Legende:=false ;
      GCT1.TreePage.DeleteLeg;
    end ;
  legendes.Enabled:=False ;
  OptionsLegendes.Enabled:=false;
  GCT1.OnChangeSelectCarac('');
  GCT1.invalidate;
  LongTot.Text:=intToStr(GCT1.TreeTotalLength);
  LongPart.Text:=intToStr(GCT1.TreeUnitLength);

  removelabel;
  ScrollBox1.Invalidate;
end;

Procedure TFormArbre.TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  col,row,i :integer;
  AName :string;
  UnCarD:TCaractD;
begin
  TabGrid1.MouseToCell(X,Y,col,row);
  if (row=0) and (col<>0) then     // selection des caractres
    begin
 // JFR modifie le 07/07/00 pour changer l'effet du bouton gauche et du bouton droit
 // Cette modification doit tre combine avec celle de MynewGrid ligne 674
      if (button=mbleft)  then
        begin
          if TabGrid1.InvalidateCol[col]=false then AName:=''
          else AName:=TabGrid1.Cells[col,row];
          if AName='' then
            begin
              if GCT1.TreePage.Flag_Legende=true then
                begin
                  GCT1.TreePage.Flag_Legende:=false ;
                  GCT1.TreePage.DeleteLeg;
                end ;
              legendes.Enabled:=False ;
              OptionsLegendes.Enabled:=false;
            end
          else legendes.Enabled:=True;
          UnCarD:=MesCarD.GetCarD(AName);
          if UnCarD<>Nil then
            for i:=0 to UnCarD.ListeEtats.Count-1 do
              if UnCarD.ListeEtats[i]<>'' then
                begin
                  if UnCarD.ListeEtats[i]='?' then NodeColor[i+1]:=clWhite
                  else if UnCarD.LitAffichCellEtat(i).Active then
                    begin
                      if UnCarD.LitAffichCellEtat(i).CouleurFond=clWhite then
                        begin
                          if UnCarD.LitAffichCellEtat(i).CouleurContour<>clBlack then
                            NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurContour
                          else if UnCarD.LitAffichCellEtat(i).CouleurTexte<>clBlack  then
                            NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurTexte
                          else
                            NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurFond;
                        end
                      else
                        NodeColor[i+1]:=UnCarD.LitAffichCellEtat(i).CouleurFond;
                    end
                  else CouleursParDefaut;
                end;
                //GCT1.ChangeNodeColor(i+1,UnCarD.LitAffichCellEtat(i).CouleurFond);
          GCT1.OnChangeSelectCarac(AName);
          GCT1.invalidate;
          LongTot.Text:=intToStr(GCT1.TreeTotalLength);
          LongPart.Text:=intToStr(GCT1.TreeUnitLength);

          if AName='' then removelabel
          else AfficheCodeColor(AName);
          ScrollBox1.Invalidate;
        end
      else
        begin
          if TabGrid1.SelectCol[col]=false then AName:=''
          else AName:=TabGrid1.Cells[col,row];

          if AName='' then
            begin
              if GCT1.TreePage.Flag_Legende=true then
                begin
                  GCT1.TreePage.Flag_Legende:=false ;
                  GCT1.TreePage.DeleteLeg;
                  //          legendes.Caption:='Afficher';
                end ;
              legendes.Enabled:=False ;
            end
          else legendes.Enabled:=True;

          GCT1.OnChangeListCarac(nil, AName);
          GCT1.invalidate;

          removelabel ;

          LongTot.Text:=intToStr(GCT1.TreeTotalLength);
          LongPart.Text:=intToStr(GCT1.TreeUnitLength);
        end;
    end;

  if (row<>0) and (col=0) then
    begin
      AName:=TabGrid1.Cells[col,row];
      If (EnleverTaxon = 'non') then exit;
      // le clic a eu lieu sur une cellule slectionne mais il la dselectionne  automatiquement
      if TabGrid1.SelectRow[row]=false then
        begin
          if TabGrid1.canDeselectRow(1)=false then    // jfr modifie le 28 septembre 2001
            begin                                     // pour empecher la dselection quand il ne reste plus que 2 taxons dans l'arbre
              Tabgrid1.SelectRow[row]:=true;            // Rappel la fonction Selfmousedown de myNewgrid qui est appele avant celle ci
              Tabgrid1.MyInvalidateCell(col,row);       // a dselectionn automatiquement la cellule; il faut donc la reselectionner
              exit;                                     //   Pour cette raison aussi on appelle canDeselectRow(1) et non pas (2)
            end;
          GCT1.DeleteTaxon(AName);
          LongTot.Text:=intToStr(GCT1.TreeTotalLength);
          LongPart.Text:=intToStr(GCT1.TreeUnitLength);
        end
      else  // le clic a eu lieu sur une cellule non selectionne au dpart
        begin
          if GCT1.NameOfFlagTaxonPro='' then
            begin
              GCT1.AddTaxonPro(AName);
              NameOfFlagTaxonPro:=AName;
              TabGrid1. SelectRow[row]:=False;
              // La cellule reste dselectionne tant que le taxon provisoire n'est pas rajout
            end;
          TabGrid1. SelectRow[row]:=False;
      end;
  end;
end;

Procedure TFormArbre.TabGrid1MouseDownFixe(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

end;

//******************************************************************************/

procedure TFormArbre.GCT1MouseUp(Sender: TObject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
Var
  LaRacineG:TGraphNode;
begin
  // La deuxime condition traduit le fait que le greffage russi d'un taxon
  // provisoire conduit  sa suppression
  if ModeEdition then
    begin
      LongPart.Text:=intToStr(GCT1.TreeUnitLength);
      LongTot.Text:=intToStr(GCT1.TreeTotalLength);
      VerifieTypeRacine;
    end
  else If (not InactiveMouseUp) then
    begin
      LaRacineG:=GCT1.GetRacineG;
      LaRacineG.RazDescendants(GCT1.CouleurAncetre,bsSolid);
      If RacineSansDerive then LaRacineG.CouleurAncetre:=CouleurAncetreRacine;
      GCT1.Refresh;
      FicheCarAncetre.Close;
      Application.ProcessMessages;
      ColoreMatrice;
    end;
  InactiveMouseUp:=False;

end;

//******************************************************************************/
procedure TFormArbre.ActionClick(Sender: TObject);
begin
  if sender = enraciner
        then GCT1.OnFlagRoot
  else if sender =pivoter
        then GCT1.OnFlagSwap
  else if sender = normal
        then GCT1.OnFlagNormal;
end;

//******************************************************************************/

procedure TFormArbre.OptionslegendesClick(Sender: TObject);
var
  res :integer;
begin
 case GCT1.TreePage.TypeEtat  of
   NEtatDown :FicheOptionLeg.EtatDownRadio.Checked:=true;
   NEtatUp : FicheOptionLeg.EtatUpRadio.Checked:=true;
   NEtatMPR : FicheOptionLeg.EtatMPRRadio.Checked:=true;
 end;

 case GCT1.TreePage.TypeLegende  of
   texte :FicheOptionLeg.TexteRadio.Checked:=true;
   codeL : FicheOptionLeg.codeRadio.Checked:=true;
 end;

 res:=FicheOptionLeg.showModal;

 if res<>mrcancel then
   begin
     if  FicheOptionLeg.EtatDownRadio.Checked=true then GCT1.TreePage.TypeEtat := NEtatDown
     else if  FicheOptionLeg.EtatUpRadio.Checked=true  then GCT1.TreePage.TypeEtat := NEtatUp
     else if  FicheOptionLeg.EtatMPRRadio.Checked=true then GCT1.TreePage.TypeEtat :=  NEtatMPR;

     if FicheOptionLeg.TexteRadio.Checked=true then GCT1.TreePage.TypeLegende := texte
     else if FicheOptionLeg.codeRadio.Checked=true  then GCT1.TreePage.TypeLegende := codeL;

     GCT1.TreePage.DeleteLeg;
     GCT1.TreePage.CreateLeg;
     GCT1.TreePage.ChangeCoordGraphObjects;

     GCT1.Invalidate;
   end;

 end;
//******************************************************************************/
procedure TFormArbre.codeClick(Sender: TObject);
begin
  If LaSousCollection<>Nil then
    begin
      if LasousCollection.Caracteres.CodesEtats<>Nil then
        begin
          AffTabCod.ConstruitTableau;
          ChoixCode.Visible:=True;
          AffTabCod.Show;
        end;
    end;
end;

procedure TFormArbre.autoClick(Sender: TObject);
begin
 GCT1.OnChangeAuto;
 LongTot.Text:=intToStr(GCT1.TreeTotalLength);
 LongPart.Text:=intToStr(GCT1.TreeUnitLength);
end;

procedure TFormArbre.annulerClick(Sender: TObject);
begin
 GCT1.UndoTreeAction;
 LongTot.Text:=intToStr(GCT1.TreeTotalLength);
 LongPart.Text:=intToStr(GCT1.TreeUnitLength);
end;

procedure TFormArbre.FormCreate(Sender: TObject);
begin
  NameOfFlagTaxonPro:='';
  ModeAfficheCarac:=true ;
  FormPrinc.Fille(Self);
  //GroupBox1.Left:=Width-GroupBox1.Width-10; // Outils  droite de la fentre
  //PanelOutils.Left:=GroupBox1.Left+((GroupBox1.Width-PanelOutils.Width)div 2); // centr sur le Groupbox
  GCT1.Width:=Round(Width*2/3);
  GCT1.EstModifiable:=True;
  GCT1.MontrerAncetre:=True;
  GCT1.CouleurAncetre:=CouleurAncHorsGroupe;
  GCT1.StyleAncetre:=bsSolid;//bsDiagCross;

  Panel1.Height:=Round(Height*2/3);
  ModeEdition:=True;
   AfDExcl:=ConvertitAffCelAffCoul(ModDeriveExcl);
   AfD:=ConvertitAffCelAffCoul(ModDerive);
   AfA:=ConvertitAffCelAffCoul(ModAncestral);

  {AfDExcl.Active:=True;
  AfDExcl.CouleurFond:=CouleurMisEnEvid;//CouleurAncDesc;
  AfDExcl.CouleurTexte:=ClBlack;
  AfDExcl.styleFond:=bsSolid;
  AfDExcl.CouleurContour:=clBlack;
  AfD:=AfDExcl;
  AfD.CouleurFond:=CouleurAncHorsGroupe;
  AfD.CouleurTexte:=clBlack;
  AfA.Active:=false;}
end;

procedure TFormArbre.zoomplusClick(Sender: TObject);
begin
  GCT1.OnChangeScale('plus');
end;

procedure TFormArbre.zoommoisClick(Sender: TObject);
begin
  GCT1.OnChangeScale('moins');
end;

procedure TFormArbre.ChargeTabGrid;
{ DL 10/02/99 correspond  arbreclick pour JFR}
var
  ListArray:TStrListArray;
  TreeGroup:TTreeGroup;
  LaRacineG:TGraphNode; //noeud racine de l'arbre clade
begin
  AjusteCode;
  GCT1.ChangeModifRacine(ModifRacine);
  GCT1.ChangeQuadrillage(Quadrillage);
  if FormPrinc.AData=Nil then FormPrinc.AData:=TStrListArray.createlistArray;
  ListArray:=FormPrinc.AData;
  if (ListArray.RowCount<2) or  (ListArray.GetMaxColCount<2) then
    begin
      if TableauCorrect then
        FormChoisir.TabGrid1.CopyToAlistArray(0,0,ListArray)
      else ListArray.Assign(LaSousCollection.TabRef);
    end;
  TabGrid1.RowCount:=ListArray.RowCount;
  TabGrid1.ColCount:=ListArray.GetMaxColCount;
  TabGrid1.copyFromAlistArray(0,0,ListArray);
  TabGrid1.SelectAllRow(true);
  TabGrid1.AdjustColWidths;
  if ArbreDApresBoites=true then  //A Revoir
    begin
   // ajout DL 20/02/98
      FormParente.TabGrid1.CopyListSelectCol(TabGrid1.ListSelectCol);
      TabGrid1.Invalidate;
      // jfr modifie le 19/12/05 pour le nouveau tri par boite
      if MesCarD.CodesEtats= nil then
        MesCarD.CreeCodeSEtats;
      TabGrid1.FTabCod:=MesCarD.CodesEtats;
      //TabGrid1.FTabCod:=TStrListArray.CopyCreate(LaSousCollection.Caracteres.CodesEtats);
      //GCT1.InitTreeBoite(TabGrid1,FormParente.GraphTri21.treeBoite,MesCarD.CodesEtats); //,Caracteres.CodeSEtats  // jfr modifie le 10/09/00   avant : formTri.tabgrid1
      Verifierarbre;
      //RadioMode.ItemIndex:=1;
    end
  else if ArbreDApresTri=true then //FormPrinc.ATri<>nil
    begin
      FormTri.TabGrid1.CopyListSelectCol(TabGrid1.ListSelectCol);
      TabGrid1.Invalidate;
      TreeGroup:=TTreeGroup(FormTri.GraphTri1.Model);  // jfr modifie le 19/12/05 pour le nouveau tri par boite
      if MesCarD.CodesEtats= nil then
        MesCarD.CreeCodeSEtats;
      TabGrid1.FTabCod:=MesCarD.CodesEtats;
      GCT1.InitTreeGroup(TabGrid1,TreeGroup,MesCarD.CodesEtats);  //,Caracteres.CodeSEtats          // jfr modifie le 10/09/00   avant : formTri.tabgrid1
      //RadioMode.ItemIndex:=1;
    end
  else
    begin
      TabGrid1.SelectAllCol(true);
      TabGrid1.SelectAllRow(true);

      if MesCarD.CodesEtats= nil then
        MesCarD.CreeCodeSEtats;
      TabGrid1.FTabCod:=MesCarD.CodesEtats;
      try
        GCT1.InitTreeCode(TabGrid1,MesCarD.CodesEtats);
      except
      end;
      Verifierarbre;
      //RadioMode.ItemIndex:=0;
    end;
  //if TableauCouleurs<>nil then TabGrid1.CopieAffichageDe(TableauCouleurs);

  MesCarD.EtablitAffichage(TabGrid1);
  LongTot.Text:=intToStr(GCT1.TreeTotalLength);
  LongPart.Text:=intToStr(GCT1.TreeUnitLength);
  VerifieTypeRacine;
  LaRacineG:=GCT1.GetRacineG;
  if  RacineSansDerive and (LaRacineG<>nil) then
    begin
      LaRacineG.CouleurAncetre:=CouleurAncetreRacine;
      GCT1.Refresh;
    end;
end;

procedure TFormArbre.SpeedButton1Click(Sender: TObject);
begin
 GCT1.FirstTreeAction;
 LongTot.Text:=intToStr(GCT1.TreeTotalLength);
 LongPart.Text:=intToStr(GCT1.TreeUnitLength);
end;

function TFormArbre.GetTabName(FileName: string): string;
//rcupre le nom de la matrice associe  un arbre
// on peut sans doute faire mieux
var
  strlist:TStringList;
  data: TFileStream;
begin
  strlist:=TStringlist.Create;
  try
    data:=TFileStream.Create(filename,fmOpenRead);
    data.seek(0,0);
    Strlist.loadfromstream(data);
    GetTabName:= ExtractFilePath(filename)+StrList.strings[0];
  finally
    strlist.free;
    if data<>nil then data.free;
  end;
end;

procedure TFormArbre.LoadTree(FileName:string);
var
  strlist:TStringList;
  data: TFileStream;
  strTree : string;
  //FicTab: string;
begin
  data:=NIL;
  strlist:=nil;
  try
    strlist:=TStringlist.Create;
    data:=TFileStream.Create(filename,fmOpenRead);

    data.seek(0,0);
    Strlist.loadfromstream(data);
    strtree:= StrList.strings[1];
    GCT1.OnChangeTree(strTree);
  finally
  strlist.free;
  data.free;
  end;
end;

procedure TFormArbre.SaveTree(FileName:string);
 begin
  // jfr modifie le 10/04/00
  // voir PhylMain
end;

// jfr modifie le 10/04/00
// Fonction ajoute
procedure TFormArbre.GCT1RespClicDownRight(WPoint: TPoint);
{var
  res  :integer;
  newtabcod :TstrListArray;}
begin
{  if ModeEdition and ((GCT1.ClicDownObject is TLegende)=false) then     // jfr modifie le 29/04/02 la condition a t rajout
    begin
      newtabcod:=GCT1.TreePage.CreateListCarac(TGraphNode(GCT1.ClicDownObject));
      FicheEtatCarac.CaracGrid1.CopyFromAListArray(0,1,newTabCod);
      res:=FicheEtatCarac.showModal;
    end;}
end;

procedure TFormArbre.GCT1BeforeInsert(sender: TObject);  // attention  la date de modification
var
  row:integer;
begin
If not ModeEdition then exit;
if (NameOfFlagTaxonPro<>'') {and (GCT1.NameOfFlagTaxonPro='') }then
  begin
    row:=TabGrid1.IndexOfRow(NameOfFlagTaxonPro);
    if row<>-1 then
      begin
        TabGrid1. SelectRow[row]:=true;
        TabGrid1.MyInvalidateCell(0,row);
        GCT1.AddTaxonToDataList(row);
      end;
    NameOfFlagTaxonPro:='';
  end;
end;

// jfr modifie octobre 2001 : procedure rajoute
procedure TFormArbre.Fontedestaxons1Click(Sender: TObject);
var
  essai:string ;
begin
  if FontDialog1.execute then begin
    essai:= FontDialog1.Font.Name;
    GCT1.Treepage.FFontTaxon.lfHeight:=FontDialog1.Font.Height;
    if (fsItalic in FontDialog1.Font.style) then GCT1.Treepage.FFontTaxon.lfItalic := 1
    else  GCT1.Treepage.FFontTaxon.lfItalic := 0;

    if (fsBold in FontDialog1.Font.style) then GCT1.Treepage.FFontTaxon.lfweight:= FW_BOLD
    else  GCT1.Treepage.FFontTaxon.lfweight:= FW_NORMAL;

    if (fsUnderline in FontDialog1.Font.style) then GCT1.Treepage.FFontTaxon.lfUnderline := 1
    else  GCT1.Treepage.FFontTaxon.lfUnderline := 0;

    strPCopy(GCT1.Treepage.FFontTaxon.lfFaceName,essai);
    GCT1.Treepage.DeleteObjects;
    GCT1.Treepage.ChangeInfoGraph ;
    GCT1.invalidate;
    end;
end;

procedure TFormArbre.Afficherleslongueurs1Click(Sender: TObject);
begin
if (GroupBox1.Visible=false) then
begin
    GroupBox1.visible:=true;
     Afficherleslongueurs1.Caption:='Masquer les longueurs';
 end
 else begin
     GroupBox1.visible:=false;
     Afficherleslongueurs1.Caption:='Afficher les longueurs';
 end
end;

procedure TFormArbre.Splitter1CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept:=False;
  if (NewSize>30) and ((Height-NewSize-Splitter1.Height)>30) then Accept:=True;
end;

procedure TFormArbre.Splitter2CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept:=False;
  if GroupBox1.Visible then
    begin
      if (NewSize>99) and (NewSize+Splitter2.Width<ClientWidth-GroupBox1.Width) then Accept:=True;
    end
  else
    if (NewSize>99) and (NewSize+Splitter2.Width<ClientWidth-PanelOutils.Width) then Accept:=True;
end;
procedure TFormArbre.AjusteActive;
Var
  i:integer;
  UnCarD:TCaractD;
  UnTaxon:TTaxon;
begin
  MesCarD.RazDActive;
  for i:=1 to TabGrid1.ColCount-1 do
    begin
      UnCarD:=MesCarD.GetCarD(TabGrid1.Cells[i,0]);
      if (UnCarD<>Nil)and(TabGrid1.SelectCol[i]) then UnCarD.Active:=True;
    end;
  LaSousCollection.Taxons.RAZSelected;
  for i:=1 to TabGrid1.RowCount-1 do
    begin
      UnTaxon:=LaSousCollection.LeTaxon(TabGrid1.Cells[0,i]);
      if (UnTaxon<>Nil)and(TabGrid1.SelectRow[i]) then UnTaxon.Selected:=True;
    end;

end;

procedure TFormArbre.VerifieTypeRacine;
var
  i,j,p:integer; //,n
  trouve:boolean;
  NomCar:string;
  LeCaracD:TCaractD;
begin
  RacineSansDerive:=True;
  for i:=1 to TabGrid1.ColCount-1 do
    begin
      trouve:=false;
      NomCar:=TabGrid1.Cells[i,0];
      LeCaracD:=MesCarD.GetCarD(NomCar);
      //n:=LaSousCollection.Caracteres.GetNumCarD(NomCar);
      if (LeCaracD<>Nil) then     //n>-1
        begin
          //LeCaracD:=MesCarD.Items[n];
          for j:=1 to TabGrid1.RowCount-1 do
            begin
              p:=LeCaracD.ListeEtats.IndexOf(TabGrid1.Cells[i,j]);
              if p<1 then
                begin
                  trouve:=true;
                  break;
                end;
            end;
          if not trouve then
            begin
              RacineSansDerive:=False;
              break;
            end;
        end;
    end;
end;

procedure TFormArbre.FormShow(Sender: TObject);
Var
  LaRacineG:TGraphNode;
begin
  AjusteCode;
  MesCarD.EtablitAffichage(TabGrid1);
  VerifieTypeRacine;
  GCT1.Refresh;
  LaRacineG:=GCT1.GetRacineG;
  if RacineSansDerive and (LaRacineG<>nil) then
    begin
      LaRacineG.CouleurAncetre:=CouleurAncetreRacine;
      GCT1.Refresh;
    end;
end;
procedure TFormArbre.RetourSelection(Sender:TObject);
Var
  L: TStringList;
  i:integer;
begin
  L:=TStringList.Create;
  L.AddStrings(FormRecherche.ListTaxons.Items);
  GCT1.RAZGroupe;
  for i:=0 to L.Count-1 do
    GCT1.AjouteTaxon(L[i]);
  GCT1.CouleurGroupe:=FormRecherche.Couleur.Color;
  GCT1.Refresh;
  L.Free;
end;

procedure TFormArbre.RadioModeClick(Sender: TObject);
Var
  n:integer;
begin
  n:=RadioMode.ItemIndex;
  Case n of
    0:begin
        FormPrinc.Editerlarbre1.Click;
      end;
    1:begin
        RAZSelCAr;
        FormPrinc.Explorerlarbre1.Click;
        
      end;
  end;
end;

procedure TFormArbre.GCT1CanClicActivate(WPoint: TPoint; var ret: Boolean);
begin
  ret:=ModeEdition;
end;

procedure TFormArbre.GCT1CanClicDown(WPoint: TPoint; var ret: Boolean);
Var
  LeNoeud:TGraphNode;
  LalisteDerivExcl:TStringList;
  //chaine:string;
  AfUtil:TAffichCoul;
  i:integer;
  LaRacineG:TGraphNode; //noeud racine de l'arbre clade
  ListeTaxons:TStringList; //Liste des taxons qui descendent de l'anctre sur lequel on a cliqu
  NomGroupe:string;
begin
  ret:=ModeEdition;
  if (Not ModeEdition) and ((GCT1.ClicDownObject is TLegende)=false) then
    begin
      VerifieTypeRacine;
      LeNoeud:=TGraphNode(GCT1.ClicDownObject);
      LaRacineG:=GCT1.GetRacineG;
      if (LeNoeud<>Nil) and Not (LeNoeud is TGraphNodeT) and LeNoeud.IsPointAtTop(WPoint) then
        begin
          InactiveMouseUp:=True;
          LaRacineG.RazDescendants(GCT1.CouleurAncetre,bsSolid);
          If RacineSansDerive and (LeNoeud=LaRacineG) then
            begin
              LaRacineG.CouleurAncetre:=CouleurAncetreRacine;
              GCT1.Refresh;
              FicheCarAncetre.Close;
              ColoreMatrice;
              //if LalisteDerivExcl<>nil then LalisteDerivExcl.Free;
              exit;
            end;
          AjusteActive;
          ListeTaxons:=TStringList.Create;
          LeNoeud.TaxonsDescendants(ListeTaxons);
          if ListeTaxons.Count>0 then
            begin
              FicheCarAncetre.LTaxons.RowCount:= ListeTaxons.Count;
              //FicheCarAncetre.CouleurDerive:=AfD.CouleurFond;
              //FicheCarAncetre.CouleurDeriveExcl:=AfDExcl.CouleurFond;
              For i:=0 to ListeTaxons.Count-1 do
                begin
                  FicheCarAncetre.LTaxons.Cells[0,i]:=ListeTaxons[i];
                end;
               //LalisteDerivExcl:=LaSousCollection.ConstruitListeEtatsAncetre(AfDExcl,AfD,AfA,NomGroupe,ListeTaxons,FicheCarAncetre.ColorStringGrid);
              AfUtil:=AfDExcl;

              LalisteDerivExcl:=ConstruireListeEtatsAncetreBis(LaSousCollection.Taxons,MesCarD,
                 LaSousCollection.TabRef,LaSousCollection.AvecFossiles,
                 AfDExcl,AfD,AfA,AfUtil,NomGroupe,ListeTaxons,FicheCarAncetre.ColorStringGrid);
              FicheCarAncetre.AfUtil:=AfUtil;
              FicheCarAncetre.VerifieTableau;
              FicheCarAncetre.Groupe:=NomGroupe;
              //FicheCarAncetre.NomGroupe.Caption:=NomGroupe;
              FicheCarAncetre.AjusteLegende;
              FicheCarAncetre.cDE:=AfUtil.CouleurFond;
              FicheCarAncetre.cD:=AfD.CouleurFond;
              FicheCarAncetre.Classer;
              //FicheCarAncetre.Classer;(AfUtil.CouleurFond,AfD.CouleurFond)
              FicheCarAncetre.Show;
            end;
          ListeTaxons.Free;

          LeNoeud.ColorieDescendants(FicheCarAncetre.CouleurArbre,FicheCarAncetre.CouleurArbre,FicheCarAncetre.StyleArbre,FicheCarAncetre.StyleArbre);
          //LeNoeud.ColorieDescendants(CouleurMisEnEvid,CouleurAncDesc,bsSolid,BsSolid); //entrenoeuds puis noeuds
          LeNoeud.CouleurAncetre:=CouleurAncetreClique;
          LeNoeud.StyleAncetre:=bsSolid;
          if  RacineSansDerive and (LaRacineG<>nil) then
            LaRacineG.CouleurAncetre:=CouleurAncetreRacine;
          GCT1.Refresh;
          if LalisteDerivExcl<>nil then LalisteDerivExcl.Free;
        end;
    end;
  Application.ProcessMessages;
  ColoreMatrice;
end;

 //GCT1.OnChangeAuto;
procedure TFormArbre.ChoixCodeClick(Sender: TObject);
begin
  AjusteCode;
end;
procedure TFormArbre.AjusteCode;
begin
  If ChoixCode.ItemIndex=0 then
    begin
      MesCarD:=LaSousCollection.Caracteres.CarDs;
    end
  else
    begin
      MesCarD:=AffTabCod.MesCarD;
    end;
  TabGrid1.FTabCod:=MesCarD.CodesEtats;
  MesCarD.EtablitAffichage(TabGrid1);
  TabGrid1.Refresh;
  GCT1.ChargeTabCod(MesCarD.CodesEtats);
  AjusteAffArbre;
end;
procedure TFormArbre.AjusteTableau;
Var
  ListArray:TStrListArray;
begin
  ListArray:=TStrListArray.createlistArray;
  FormChoisir.TabGrid1.CopyToAlistArray(0,0,ListArray);
  TabGrid1.RowCount:=FormChoisir.TabGrid1.RowCount;
  TabGrid1.ColCount:=FormChoisir.TabGrid1.ColCount;

  TabGrid1.copyFromAlistArray(0,0,ListArray);

  TabGrid1.SelectAllCol(true);
  TabGrid1.SelectAllRow(true);
  MesCarD.EtablitAffichage(TabGrid1);
  ListArray.Free;
end;

procedure TFormArbre.TableaudesdistancesClick(Sender: TObject);
Var
  i,j,k,n,h,l:integer;
begin
  FormTabDist.ColorStringGrid1.ColCount:=TabGrid1.RowCount-1;
  FormTabDist.ColorStringGrid1.RowCount:=TabGrid1.RowCount-1;
  For i:=1 to TabGrid1.RowCount-1 do
    begin
      if i>1 then FormTabDist.ColorStringGrid1.Cells[i-1,0]:=TabGrid1.Cells[0,i];
      if i<(TabGrid1.RowCount-1) then FormTabDist.ColorStringGrid1.Cells[0,i]:=TabGrid1.Cells[0,i];
      For j:=i+1 to TabGrid1.RowCount-1 do
        begin
          n:=0;
          for k:=1 to TabGrid1.ColCount-1 do
            if TabGrid1.Cells[k,i]<>TabGrid1.Cells[k,j] then inc(n);
          FormTabDist.ColorStringGrid1.Cells[j-1,i]:=IntToStr(n);
        end;
    end;
  For i:=2 to TabGrid1.RowCount-2 do
    FormTabDist.ColorStringGrid1.Cells[i-1,i]:='0';
  l:=FormTabDist.ColorStringGrid1.ajusteColonnes;
  h:=FormTabDist.ColorStringGrid1.GridLineWidth+FormTabDist.ColorStringGrid1.RowCount
    *(FormTabDist.ColorStringGrid1.DefaultRowHeight+FormTabDist.ColorStringGrid1.GridLineWidth)+1;
  FormTabDist.ClientWidth:=l+20;
  FormTabDist.ClientHeight:=h+20;
  FormTabDist.ClientWidth:=l;
  FormTabDist.ClientHeight:=h+2;
  FormTabDist.Show;
end;

end.

